Reference information for serverless functions built with the design manager, including serverless.json, function files, endpoints, CLI commands, and managing packages.
Supported products
Please note:This page contains reference information for serverless functions built using the design manager. Historically, this is the original way to build serverless functions for your CMS pages, and is still supported. However, moving forward it’s recommended to build and deploy serverless functions with HubSpot developer projects. Project-based serverless functions can include third-party dependencies, and have more direct access to authentication through private app access tokens.
In the .functions folder, the serverless.json file stores the serverless function configuration. This is a required file, and maps your functions to their endpoints.
The runtime environment. Supports Node.js v20 (nodejs20.x).
version
String
HubSpot serverless function schema version. (Current version 1.0)
environment
Object
Configuration variables passed to the executing function as environment variables at runtime. You might use this to add logic for using a testing version of an API instead of the real thing based on an environment variable.
secrets
Array
An array containing the names of the secrets your serverless function will use for authentication. Do not store secret values directly in this file, only reference secret names.
endpoints
Object
Endpoints define the paths that are exposed and their mapping to specific JavaScript files, within your functions folder. Learn more about endpoints.
HubSpot will no longer support Node 18 beyond October 1, 2025. Beyond that date, serverless functions with a runtime below v20 will not be able to be deployed.
Please note:Do not assign the same name to your secrets and environment variables. Doing so will result in conflicts when returning their values in the function.
Each endpoint can have its own environment variables and secrets. Variables specified outside of endpoints should be used for configuration settings that apply to all functions and endpoints.
Path to JavaScript function file with the implementation for the endpoint.
The endpoint can be invoked by calling a URL at one of the domains connected to HubSpot account, including the default .hs-sites.com subdomains, with the following URL structure:https://{domainName}/_hcms/api/{endpoint-name/path}?portalid={hubId}.
Parameter
Description
domainName
A domain connected to the HubSpot account.
/_hcms/api/
The path reserved for serverless functions. All endpoints exist inside this path.
endpoint-name/path
The endpoint name or path that you specified in the serverless.json file.
portalid
An optional query parameter containing your HubSpot account ID. Providing this in the request will enable you to test your functions within module and template previews.
For example, if both website.com and subdomain.brand.com are connected to the account, you could call the function using either https://website.com/_hcms/api/{endpoint-name/path} or https://subdomain.brand.com/_hcms/api/{endpoint-name/path}.
In addition to the serverless.json configuration file, the .functions folder will also contain a Node.js JavaScript file that defines the function. You can also leverage the request library to make HTTP request to HubSpot APIs and other APIs.For example:
Report incorrect code
Copy
Ask AI
// Require axios library, to make API requests.const axios = require("axios");// Environment variables from your serverless.json// process.env.globalConfigKeyexports.main = (context, sendResponse) => { // your code called when the function is executed // context.params // context.body // context.accountId // context.limits // secrets created using the CLI are available in the environment variables. // process.env.secretName //sendResponse is what you will send back to services hitting your serverless function. sendResponse({ body: { message: "my response" }, statusCode: 200 });};
The context object contains contextual information about the function’s execution, stored in the following parameters.
Parameter
Description
accountId
The HubSpot account ID containing the function.
body
Populated if the request is sent as a POST with a content type of application/json.
contact
If the request is from a cookied contact, the contact object will be populated with a set of basic contact properties along with the following information:
vid: The contact’s visitor ID.
isLoggedIn: when using CMS Memberships, this will be true if the contact is logged in to the domain.
listMemberships: an array of contact list IDs that this contact is a member of.
headers
Contains the headers sent from the client hitting your endpoint.
params
Populated with query string values along with any HTML Form-POSTed values. These are structured as a map with strings as keys and an array of strings for each value.context.params.yourvalue
If you need to know the headers of the client that’s hitting your endpoint, you can access them through context.headers, similar to how you would access information through context.body.Below, review some of the common headers that HubSpot provides. For a full list, see MDN’s HTTP headers documentation.
header
Description
accept
Communicates which content types expressed as MIME types, the client understands. See MDN.
accept-encoding
Communicates the content encoding the client understands. See MDN.
accept-language
Communicates which human language and locale is preferred. See MDN.
For headers that support multiple values, you can use multiValueHeaders, to pass the values. For example: you can tell the browser to set multiple cookies.
When you need to authenticate a serverless function request, you’ll use secrets to store values such as API keys or private app access tokens. Using the CLI, you can add secrets to your HubSpot account to store those values, which you can later access through environment variables (process.env.secretName). Secrets are managed through the HubSpot CLI using the following commands:
Once added through the CLI, secrets can be made available to functions by including a secrets array containing the name of the secret. This enables you to store your function code in version control and use secrets without exposing them. However, you should never return your secret’s value through console logging or as a response, as this will expose the secret in logs or in front-end pages that call your serverless function.
Please note:Due to caching, it can take about one minute to see updated secret values. If you’ve just updated a secret but are still seeing the old value, check again after about a minute.
When submitting serverless functions use javascript to handle the form submission, and use the "contentType" : "application/json" header in your request. Do not use the <form> elements action attribute.
Cross Origin Resource Sharing (CORS) is a browser security feature. By default browsers restrict cross-origin requests initiated by javascript. This prevents malicious code running on a different domain, from affecting your site. This is called the same-origin policy. Because sending and retrieving data from other servers is sometimes a necessity, the external server, can supply HTTP headers that communicate which origins are permitted to read the information from a browser.You should not run into CORS issues calling your serverless function within your HubSpot hosted pages. If you do, verify you are using the correct protocol.
Getting this CORS error?“Access to fetch at [your function url] from origin [page making request] has been blocked by CORS policy: Response to preflight request doesn’t pass access control check: No ‘Access-Control-Allow-Origin’ header is present on the requested resource. If an opaque response serves your needs, set the request’s mode to ‘no-cors’ to fetch the resource with CORS disabled.”Is your request to a different origin than the site calling it?
To use the latest supported version of a preloaded package, or to use a newly added package:
Clone or copy your function file.
Change your function’s endpoint in the serverless.json file to point to your new function file. You can safely delete the old version.
If you want to include packages outside of the preloaded package set, you can use webpack to combine your node modules and have your bundled files be your function files.
Serverless functions are intended to be fast and have a narrow focus. To enable quick calls and responses, HubSpot serverless functions have the following limits:
50 secrets per account.
128MB of memory.
No more than 100 endpoints per HubSpot account.
You must use contentTypeapplication/json when calling a function.
Serverless function logs are stored for 90 days.
6MB on an AWS Lambda invocation payload.
Execution limits
Each function has a maximum of 10 seconds of execution time.
Each account is limited to 600 total execution seconds per minute.
This means either of these scenarios can happen:
60 function executions that take 10 seconds each to complete.
6,000 function executions that take 100 milliseconds to complete.
Functions that exceed those limits will throw an error. Execution count and time limits will return a 429 response. The execution time of each function is included in the serverless function logs.To assist in avoiding these limits, limit data is provided automatically to the function context during execution. You can use that to influence your application to stay within those limits. For example, if your application requires polling your endpoint, then you can return with your data a variable to influence the frequency of the polling. That way when traffic is high you can slow the rate of polling avoiding hitting limits, then ramp it back up when traffic is low.
Last modified on January 28, 2026
Was this page helpful?
⌘I
Assistant
Responses are generated using AI and may contain mistakes.